#ifndef _Body_h_
#define _Body_h_

#include <vector>
#include <iostream>

#ifndef _Vec2_h_
# include "Vec2.h"
#endif

using namespace std;

class Body
{
  public:
    
    Body(const V2f &end1, const V2f &end2, float mass);

    const float M;
    const float oneOverM;

    const float lengthOverTwo;

    const float I;
    const float oneOverI;

    const V2f _end1orig;
    const V2f _end2orig;


    V2f pos;
    V2f vel;
    V2f F;

    float theta;
    float omega;
    float N;

    V2f dir;

    V2f end1pos;
    V2f end2pos;

    V2f fpos;
    V2f fvel;

    float ftheta;
    float fomega;
    V2f fdir;
    V2f fperp;

    V2f   fend1pos;
    V2f   fend1vel;

    V2f   fend2pos;
    V2f   fend2vel;

    void  reset();
    void  unparse(ostream &out) const;

    typedef vector<Body *> container;
};


#endif // _Body_h_
