#ifndef _Joint_h_
#define _Joint_h_

#include <vector>
#include <iostream>

using namespace std;

class Body;
class Exp;

class Joint
{
  public:
    Joint(int body1, float body1off, int body2, float body2off, 
          float t_theta, Exp *t_exp);
    virtual ~Joint();

    int   b1;
    int   b2;
    float b1off;
    float b2off;
    float target_theta; // base angle
    Exp * target_exp; // offset(t)

    float sign;
    float prev_theta;
    float max_dtarget;

    virtual void  unparse(ostream &out) const;
    void          reset();

    typedef vector<Joint *> container;

  protected:

    void  unparseRemainder(ostream &out) const;
};

class ConstantJoint : public Joint
{
  public:
    ConstantJoint(int body1, float body1off, int body2, float body2off, 
                  float t_theta);
    virtual ~ConstantJoint();
    virtual void  unparse(ostream &out) const;
};

#endif // _Joint_h_
